#ifndef ___CONFIG_PARSER_H
#define ___CONFIG_PARSER_H
#include <string>
#include <map>
#include <vector>
#include "R3Graphics/R3Graphics.h"
// a static class
class ConfigParser
{
public:
    enum {SUM, MIN} SpatialOperation;
public:
	ConfigParser(void);
	void Import(const char* filename, RNBoolean create_new = FALSE);
    void ImportFrequentlyUsedParameters(void);
    // Check
    RNBoolean HasSection(const std::string& sec) const;
	RNBoolean HasOption(const std::string& sec,
						const std::string& opt) const;
	RNBoolean IsLoaded(void) const;
    // Set
    void Set(const std::string& sec, const std::string& opt,
			 const std::string& val, RNBoolean create_new = FALSE);
    // Get
	RNScalar GetScalar(const std::string& sec, const std::string& opt) const;
	int GetInt(const std::string& sec, const std::string& opt) const;
	const std::string Get(const std::string& sec,
						  const std::string& opt) const;
	const char* GetCharArray(const std::string& sec,
							 const std::string& opt) const;
    const std::vector<std::string> GetStringArray(const std::string& sec,
                                                  const std::string& opt) const;
	const std::vector<RNScalar> GetScalarArray(const std::string& sec,
                                               const std::string& opt) const;
    const std::vector<int> GetIntArray(const std::string& sec,
                                       const std::string& opt) const;
    RNBoolean IsEnabled(const std::string& sec,
						const std::string& opt) const;
    // Print all sections and options
    void PrintAllSettings(void) const;
public:
    // frequently used variables
    R3Vector prescribed_direction;
protected:
	// Data
    std::map<std::string, std::map<std::string,std::string> > values;
	RNBoolean isLoaded;
};

extern ConfigParser MyConfigParser;
#endif
