#ifndef MY_R2_MY_PIXEL_H
#define MY_R2_MY_PIXEL_H
class R2MyPixel
{
public:
    R2MyPixel(void);
    R2MyPixel(int _x, int _y, RNRgb _c, R3MySceneNode* _owner = NULL);
    R2MyPixel(const R2MyPixel& _pixel);
public:
    // property functions
    int X(void) const;
    int Y(void) const;
    const R2Point Position(void) const;
    const R2Vector& Normal(void) const;
    const RNRgb& Color(void) const;
    const R3Vector LABColor(void) const;
    const R3Vector XYZColor(void) const;
    R3MySceneNode* Owner(void) const;
    // distance in coordinate
    RNLength CoordinateDistance(const R2MyPixel& pixel) const;
    // assignment operators
    R2MyPixel& operator=(const R2MyPixel& _pixel);
    RNBoolean operator==(const R2MyPixel& _pixel) const;
    RNBoolean operator!=(const R2MyPixel& _pixel) const;
    void SetPosition(int x, int y);
    void SetNormal(const R2Vector& n);
    void SetOwner(R3MySceneNode* _owner);
    void SetColor(const RNRgb& color);
protected:
    RNScalar ColorForwardTransformation(RNScalar r) const;
    int x, y;
    RNRgb color;
    R3MySceneNode* owner;
    R2Vector normal;
};
#endif