import numpy
import os
import sys
import ConfigParser

#def get_shape_descriptor_filename(basename, descriptorName):

#def get_part_based_shape_descriptor_filename(basename, descriptorName, labelName):

#def get_attribute_filename(basename, attributeName):

def euclidean_distance(desc1, desc2):
    # please call euclidean distance from numpy
    return numpy.linalg.norm(desc1-desc2)

def read(sd_filename):
    numbers = numpy.loadtxt(sd_filename)
    numbers = numpy.matrix(numbers)
    # we store a row vector in the file
    numbers = numbers.reshape(numbers.size,1)
    return numbers

def write(mesh_filename, sd_filename):
    cmd = ['gen_shape_descriptors', 
           '-Input', 'mesh_filename', mesh_filename, 
           '-Output', 'shape_descriptor_filename', sd_filename]
    os.system(' '.join(cmd))
    
def retrieve_descriptors(basename, descriptorNameArray):
    count = 0
    for descriptorName in descriptorNameArray:
        sdFilename = get_shape_descriptor_filename(basename, descriptorName)
        newDescriptors = read(sdFilename)
        if count == 0:
            descriptors = newDescriptors
        else:
            descriptors = numpy.concatenate((descriptors, newDescriptors))
        count = count + 1
    return descriptors

def retrieve_part_based_descriptors(basename, descriptorNameArray, partLabelNameArray):
    count = 0
    for partLabelName in partLabelNameArray:
        for descriptorName in descriptorNameArray:
            sdFilename = get_part_based_shape_descriptor_filename(basename, descriptorName, partLabelName)
            newDescriptors = read(sdFilename)
            if count == 0:
                descriptors = newDescriptors
            else:
                descriptors = numpy.concatenate((descriptors, newDescriptors))
            count = count + 1
    return descriptors

def retrieve_part_based_descriptors_with_names(basename, descriptorNameArray, partLabelNameArray):
    count = 0
    dimNameArray = []
    for partLabelName in partLabelNameArray:
        for descriptorName in descriptorNameArray:
            sdFilename = get_part_based_shape_descriptor_filename(basename, descriptorName, partLabelName)
            newDescriptors = read(sdFilename)
            if count == 0:
                descriptors = newDescriptors
            else:
                descriptors = numpy.concatenate((descriptors, newDescriptors))
            count = count + 1
            for idx in range(numDescriptors.size):
                dimNameArray.append('%s-%s-%d'%(partLabelName,descriptorName,idx))
    return descriptors,dimNameArray

def retrieve_attributes(basename, attributeTypeArray):
    count = 0
    for attrName in attributeTypeArray:
        sdFilename = get_attribute_filename(basename, attrName)
        newAttributes = read(sdFilename)
        if count == 0:
            attributes = read(sdFilename)
        else:
            attributes = numpy.concatenate((attributes, newAttributes))
        count = count + 1
    return attributes
